<?php
/*
 * Szkolenie: Bezpieczeństwo aplikacji internetowych
 * Plik składowy przykładowego projektu
 * Autor: Marcin Lis, http://marcinlis.com
 * Uwaga: Do wszystkich projektów w celach demonstracyjnych zostały wprowdzone błędy.
 * Tych przykładów nigdy nie należy używać w praktyce.
 */

//symulacja listy kategorii
$kategorie = array(1 => 'Gospodarka', 2 => 'Komputery');
 
class Site
{
  private $dbo = null;
  function initDB($host, $user, $pass, $db)
  {
    $this->dbo = new mysqli($host, $user, $pass, $db);
    if($this->dbo->connect_errno){
      $msg = "Brak połączenia z bazą danych: ";
      $msg .= $this->dbo->connect_error;
      throw new Exception($msg);
    }
    $this->dbo->set_charset('utf8');
  }
  function setMessage($msg)
  {
    $_SESSION['message'] = $msg;
  }
  function deleteMessage()
  {
    if(isset($_SESSION['message'])){
      unset($_SESSION['message']);
    }
  }
  function getCategoriesList()
  {
    $query  = "SELECT Id, Nazwa FROM Kategorie";
    
    if(!$result = $this->dbo->query($query)){
      return array();
    }
    
    if(!$rows = $result->fetch_all(MYSQLI_ASSOC)){
      return array();
    }
    return $rows;
  }
  function isCategoryIdValid($cid)
  {
    $query  = "SELECT Id FROM Kategorie";
    
    if(!$result = $this->dbo->query($query)){
      return false;
    }
    
    if(!$rows = $result->fetch_all(MYSQLI_NUM)){
      return false;
    }
    foreach($rows as $row){
      if($cid == $row['0']){
        return true;
      }
    }
    return false;
  }
  function getData()
  {
    $cidStr = '';
    
    if(isset($_REQUEST['cid']) && $this->isCategoryIdValid($_REQUEST['cid'])){
      $cidStr = "AND kategoria = {$_REQUEST['cid']}";
    }

    $query  = "SELECT * FROM News WHERE aktywna = 1 $cidStr";

    if(!$result = $this->dbo->query($query)){
      $this->setMessage('Lista wiadomości nie jest dostępna.');
      return array();
    }
    
    if(!$rows = $result->fetch_all(MYSQLI_ASSOC)){
      $this->setMessage('Lista wiadomości nie jest dostępna.');
      return array();
    }  
    return $rows;
  }
  function showMain()
  {
    $kategorie = $this->getCategoriesList();
    $data = $this->getData();
    include 'tmpl/main.tpl';
  }
}

?>